<template>
    <div class="message-body" @click="closeMessage">
        <div v-for="message in msg.values" class="message-box"
        :style="{border: message.status == 200 ? '1px solid var(--color-positive)' : '1px solid var(--color-negative)'}">
            <div><span :style="{color: message.status == 200 ? 'var(--color-positive)' : 'var(--color-negative)'}">
                {{ message.status == 200 ? 'Success' : 'Error/Warning' }}: </span>{{ message.msg }}</div>
            <span style="font-size:8px">Click to close</span>
        </div>
    </div>
</template>

<script setup lang="ts">
import { useMessageStore, type Message } from '@/stores/message';
import { watch } from 'vue';

const msg = useMessageStore();

/**
 * Closes the oldest message.
 */
const closeMessage = () => {
    const current_message = msg?.messages.dequeue();
}

/**
 * Causes messages to auto-close after a while.
 */
watch(msg.values, () => {
    if (msg.size)
        setTimeout(() => {
            closeMessage();
        }, 7500);
});

</script>

<style scoped>

.message-body {
    min-width: 400px;
    max-width: 600px;
    height: fit-content;
    position: fixed;
    bottom: 0;
    left: 50%;
    transform: translate(-50%, 0);
    margin-bottom: 5rem;
    display: flex;
    align-items: center;
    justify-content: center;
    gap: 0.75rem;
    flex-direction: column;
    z-index: 1001;
}

.message-box {
    animation: fadeOut 8s;
    min-width: 400px;
    text-align: center;
    font-size: smaller;
    background-color: var(--color-bg);
    border: 1px solid;
    box-shadow: 0 0 0.25rem var(--color-text);
    padding: 1rem;
    display: flex;
    flex-direction: column;
    z-index: 1001;
}

@keyframes fadeOut {
    0% { opacity: 1; }
    50% { opacity: 1; }
    100% { opacity: 0; }
}

</style>
